diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-spectrum-value-helper.cc ns-3.43/src/wifi/model/wifi-spectrum-value-helper.cc
--- ns-3.42/src/wifi/model/wifi-spectrum-value-helper.cc	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-spectrum-value-helper.cc	2024-10-09 16:41:10.132656800 -0700
@@ -465,348 +591,534 @@
     auto puncturedSlopeWidth =
         static_cast<uint32_t>((500e3 / carrierSpacing) +
                               0.5); // size in number of subcarriers of the punctured slope band
-    std::vector<WifiSpectrumBandIndices> puncturedBands;
+    std::vector<std::vector<WifiSpectrumBandIndices>> puncturedBandsPerSegment;
     std::size_t subcarriersPerSuband = (20 * 1e6 / carrierSpacing);
     uint32_t start = (nGuardBands / 2);
     uint32_t stop = start + subcarriersPerSuband - 1;
-    for (auto puncturedSubchannel : puncturedSubchannels)
+    if (!puncturedSubchannels.empty())
     {
-        if (puncturedSubchannel)
+        for (std::size_t i = 0; i < subBandsPerSegment.size(); ++i)
         {
-            puncturedBands.emplace_back(start, stop);
+            puncturedBandsPerSegment.emplace_back();
+        }
+    }
+    std::size_t prevPsdIndex = 0;
+    for (std::size_t i = 0; i < puncturedSubchannels.size(); ++i)
+    {
+        std::size_t psdIndex = (puncturedBandsPerSegment.size() == 1)
+                                   ? 0
+                                   : ((i < (puncturedSubchannels.size() / 2)) ? 0 : 1);
+        if (psdIndex != prevPsdIndex)
+        {
+            start += nUnallocatedBands;
+            stop += nUnallocatedBands;
+        }
+        if (puncturedSubchannels.at(i))
+        {
+            puncturedBandsPerSegment.at(psdIndex).emplace_back(start, stop);
         }
         start = stop + 1;
         stop = start + subcarriersPerSuband - 1;
+        prevPsdIndex = psdIndex;
     }
 
     // Build transmit spectrum mask
     CreateSpectrumMaskForOfdm(c,
-                              subBands,
+                              subBandsPerSegment,
                               maskBand,
-                              txPowerPerBandW,
+                              txPowerPerBand,
                               nGuardBands,
                               innerSlopeWidth,
-                              minInnerBandDbr,
-                              minOuterBandDbr,
-                              lowestPointDbr,
-                              puncturedBands,
+                              minInnerBand,
+                              minOuterBand,
+                              lowestPoint,
+                              puncturedBandsPerSegment,
                               puncturedSlopeWidth);
-    NormalizeSpectrumMask(c, txPowerW);
-    NS_ASSERT_MSG(std::abs(txPowerW - Integral(*c)) < 1e-6, "Power allocation failed");
+    NormalizeSpectrumMask(c, txPower);
+    NS_ASSERT_MSG(std::abs(txPower - Integral(*c)) < 1e-6, "Power allocation failed");
     return c;
 }
 
 Ptr<SpectrumValue>
-WifiSpectrumValueHelper::CreateHeMuOfdmTxPowerSpectralDensity(uint32_t centerFrequency,
-                                                              uint16_t channelWidth,
-                                                              double txPowerW,
-                                                              uint16_t guardBandwidth,
-                                                              const WifiSpectrumBandIndices& ru)
-{
-    NS_LOG_FUNCTION(centerFrequency << channelWidth << txPowerW << guardBandwidth << ru.first
-                                    << ru.second);
-    uint32_t carrierSpacing = 78125;
+WifiSpectrumValueHelper::CreateHeMuOfdmTxPowerSpectralDensity(
+    const std::vector<MHz_u>& centerFrequencies,
+    MHz_u channelWidth,
+    Watt_u txPower,
+    MHz_u guardBandwidth,
+    const std::vector<WifiSpectrumBandIndices>& ru)
+{
+    auto printRuIndices = [](const std::vector<WifiSpectrumBandIndices>& v) {
+        std::stringstream ss;
+        for (const auto& [start, stop] : v)
+        {
+            ss << start << "-" << stop << " ";
+        }
+        return ss.str();
+    };
+    NS_LOG_FUNCTION(printFrequencies(centerFrequencies)
+                    << channelWidth << txPower << guardBandwidth << printRuIndices(ru));
+    const Hz_u carrierSpacing = 78125;
     Ptr<SpectrumValue> c = Create<SpectrumValue>(
-        GetSpectrumModel(centerFrequency, channelWidth, carrierSpacing, guardBandwidth));
+        GetSpectrumModel(centerFrequencies, channelWidth, carrierSpacing, guardBandwidth));
 
     // Build spectrum mask
     auto vit = c->ValuesBegin();
     auto bit = c->ConstBandsBegin();
-    double txPowerPerBandW = (txPowerW / (ru.second - ru.first + 1)); // FIXME: null subcarriers
+    const auto numSubcarriers =
+        std::accumulate(ru.cbegin(), ru.cend(), 0, [](uint32_t sum, const auto& p) {
+            return sum + (p.second - p.first) + 1;
+        });
+    const auto txPowerPerBand = (txPower / numSubcarriers); // FIXME: null subcarriers
     uint32_t numBands = c->GetSpectrumModel()->GetNumBands();
+    const auto psd = txPowerPerBand / (bit->fh - bit->fl);
     for (size_t i = 0; i < numBands; i++, vit++, bit++)
     {
-        if (i < ru.first || i > ru.second) // outside the spectrum mask
-        {
-            *vit = 0.0;
-        }
-        else
-        {
-            *vit = (txPowerPerBandW / (bit->fh - bit->fl));
-        }
+        const auto allocated = std::any_of(ru.cbegin(), ru.cend(), [i](const auto& p) {
+            return (i >= p.first && i <= p.second);
+        });
+        *vit = allocated ? psd : 0.0;
     }
 
     return c;
 }
 
-Ptr<SpectrumValue>
-WifiSpectrumValueHelper::CreateNoisePowerSpectralDensity(uint32_t centerFrequency,
-                                                         uint16_t channelWidth,
-                                                         uint32_t carrierSpacing,
-                                                         double noiseFigure,
-                                                         uint16_t guardBandwidth)
-{
-    Ptr<SpectrumModel> model =
-        GetSpectrumModel(centerFrequency, channelWidth, carrierSpacing, guardBandwidth);
-    return CreateNoisePowerSpectralDensity(noiseFigure, model);
-}
-
-Ptr<SpectrumValue>
-WifiSpectrumValueHelper::CreateNoisePowerSpectralDensity(double noiseFigureDb,
-                                                         Ptr<SpectrumModel> spectrumModel)
-{
-    NS_LOG_FUNCTION(noiseFigureDb << spectrumModel);
-
-    // see "LTE - From theory to practice"
-    // Section 22.4.4.2 Thermal Noise and Receiver Noise Figure
-    const double kT_dBm_Hz = -174.0; // dBm/Hz
-    double kT_W_Hz = DbmToW(kT_dBm_Hz);
-    double noiseFigureLinear = std::pow(10.0, noiseFigureDb / 10.0);
-    double noisePowerSpectralDensity = kT_W_Hz * noiseFigureLinear;
-
-    Ptr<SpectrumValue> noisePsd = Create<SpectrumValue>(spectrumModel);
-    (*noisePsd) = noisePowerSpectralDensity;
-    NS_LOG_INFO("NoisePowerSpectralDensity has integrated power of " << Integral(*noisePsd));
-    return noisePsd;
-}
-
 void
 WifiSpectrumValueHelper::CreateSpectrumMaskForOfdm(
     Ptr<SpectrumValue> c,
-    const std::vector<WifiSpectrumBandIndices>& allocatedSubBands,
+    const std::vector<std::vector<WifiSpectrumBandIndices>>& allocatedSubBandsPerSegment,
     const WifiSpectrumBandIndices& maskBand,
-    double txPowerPerBandW,
+    Watt_u txPowerPerBand,
     uint32_t nGuardBands,
     uint32_t innerSlopeWidth,
-    double minInnerBandDbr,
-    double minOuterBandDbr,
-    double lowestPointDbr,
-    const std::vector<WifiSpectrumBandIndices>& puncturedBands,
+    dBr_u minInnerBand,
+    dBr_u minOuterBand,
+    dBr_u lowestPoint,
+    const std::vector<std::vector<WifiSpectrumBandIndices>>& puncturedBandsPerSegment,
     uint32_t puncturedSlopeWidth)
 {
-    NS_LOG_FUNCTION(c << allocatedSubBands.front().first << allocatedSubBands.back().second
-                      << maskBand.first << maskBand.second << txPowerPerBandW << nGuardBands
-                      << innerSlopeWidth << minInnerBandDbr << minOuterBandDbr << lowestPointDbr
-                      << puncturedSlopeWidth);
-    uint32_t numSubBands = allocatedSubBands.size();
+    NS_ASSERT_MSG(allocatedSubBandsPerSegment.size() <= 2,
+                  "Only PSDs for up to 2 frequency segments are supported");
+    NS_ASSERT(puncturedBandsPerSegment.empty() ||
+              (puncturedBandsPerSegment.size() == allocatedSubBandsPerSegment.size()));
+    NS_LOG_FUNCTION(c << allocatedSubBandsPerSegment.front().front().first
+                      << allocatedSubBandsPerSegment.front().back().second << maskBand.first
+                      << maskBand.second << txPowerPerBand << nGuardBands << innerSlopeWidth
+                      << minInnerBand << minOuterBand << lowestPoint << puncturedSlopeWidth);
+    uint32_t numSubBands = allocatedSubBandsPerSegment.front().size();
     uint32_t numBands = c->GetSpectrumModel()->GetNumBands();
     uint32_t numMaskBands = maskBand.second - maskBand.first + 1;
     NS_ASSERT(numSubBands && numBands && numMaskBands);
-    NS_LOG_LOGIC("Power per band " << txPowerPerBandW << "W");
+    NS_LOG_LOGIC("Power per band " << txPowerPerBand << "W");
 
     // Different power levels
-    double txPowerRefDbm = (10.0 * std::log10(txPowerPerBandW * 1000.0));
-    double txPowerInnerBandMinDbm = txPowerRefDbm + minInnerBandDbr;
-    double txPowerMiddleBandMinDbm = txPowerRefDbm + minOuterBandDbr;
-    double txPowerOuterBandMinDbm =
-        txPowerRefDbm + lowestPointDbr; // TODO also take into account dBm/MHz constraints
+    dBm_u txPowerRef = (10.0 * std::log10(txPowerPerBand * 1000.0));
+    dBm_u txPowerInnerBandMin = txPowerRef + minInnerBand;
+    dBm_u txPowerMiddleBandMin = txPowerRef + minOuterBand;
+    dBm_u txPowerOuterBandMin =
+        txPowerRef + lowestPoint; // TODO also take into account dBm/MHz constraints
 
     // Different widths (in number of bands)
     uint32_t outerSlopeWidth =
         nGuardBands / 4; // nGuardBands is the total left+right guard band. The left/right outer
                          // part is half of the left/right guard band.
     uint32_t middleSlopeWidth = outerSlopeWidth - (innerSlopeWidth / 2);
-    WifiSpectrumBandIndices outerBandLeft(
-        maskBand.first, // to handle cases where allocated channel is
-                        // under WifiPhy configured channel width.
-        maskBand.first + outerSlopeWidth - 1);
-    WifiSpectrumBandIndices middleBandLeft(outerBandLeft.second + 1,
-                                           outerBandLeft.second + middleSlopeWidth);
-    WifiSpectrumBandIndices innerBandLeft(
-        allocatedSubBands.front().first - innerSlopeWidth,
-        allocatedSubBands.front().first -
-            1); // better to place slope based on allocated subcarriers
-    WifiSpectrumBandIndices flatJunctionLeft(
-        middleBandLeft.second + 1,
-        innerBandLeft.first - 1); // in order to handle shift due to guard subcarriers
-    WifiSpectrumBandIndices outerBandRight(
-        maskBand.second - outerSlopeWidth + 1,
-        maskBand.second); // start from outer edge to be able to compute flat junction width
-    WifiSpectrumBandIndices middleBandRight(outerBandRight.first - middleSlopeWidth,
-                                            outerBandRight.first - 1);
-    WifiSpectrumBandIndices innerBandRight(allocatedSubBands.back().second + 1,
-                                           allocatedSubBands.back().second + innerSlopeWidth);
-    WifiSpectrumBandIndices flatJunctionRight(innerBandRight.second + 1, middleBandRight.first - 1);
+
+    std::vector<WifiSpectrumBandIndices> outerBandsLeft;
+    std::vector<WifiSpectrumBandIndices> middleBandsLeft;
+    std::vector<WifiSpectrumBandIndices> flatJunctionsLeft;
+    std::vector<WifiSpectrumBandIndices> innerBandsLeft;
+    std::vector<WifiSpectrumBandIndices> allocatedSubBands;
+    std::vector<WifiSpectrumBandIndices> innerBandsRight;
+    std::vector<WifiSpectrumBandIndices> flatJunctionsRight;
+    std::vector<WifiSpectrumBandIndices> middleBandsRight;
+    std::vector<WifiSpectrumBandIndices> outerBandsRight;
+    std::optional<WifiSpectrumBandIndices> betweenPsdsBand;
+
+    allocatedSubBands.emplace_back(allocatedSubBandsPerSegment.front().front().first,
+                                   allocatedSubBandsPerSegment.front().back().second);
+    outerBandsLeft.emplace_back(maskBand.first, // to handle cases where allocated channel is
+                                                // under WifiPhy configured channel width.
+                                maskBand.first + outerSlopeWidth - 1);
+    middleBandsLeft.emplace_back(outerBandsLeft.front().second + 1,
+                                 outerBandsLeft.front().second + middleSlopeWidth);
+    innerBandsLeft.emplace_back(allocatedSubBands.front().first - innerSlopeWidth,
+                                allocatedSubBands.front().first -
+                                    1); // better to place slope based on allocated subcarriers
+    flatJunctionsLeft.emplace_back(middleBandsLeft.front().second + 1,
+                                   innerBandsLeft.front().first -
+                                       1); // in order to handle shift due to guard subcarriers
+    uint32_t flatJunctionWidth =
+        flatJunctionsLeft.front().second - flatJunctionsLeft.front().first + 1;
+    innerBandsRight.emplace_back(allocatedSubBands.front().second + 1,
+                                 allocatedSubBands.front().second + innerSlopeWidth);
+    flatJunctionsRight.emplace_back(innerBandsRight.front().second + 1,
+                                    innerBandsRight.front().second + flatJunctionWidth);
+    middleBandsRight.emplace_back(flatJunctionsRight.front().second + 1,
+                                  flatJunctionsRight.front().second + middleSlopeWidth);
+    outerBandsRight.emplace_back(middleBandsRight.front().second + 1,
+                                 middleBandsRight.front().second + outerSlopeWidth);
+
+    if (allocatedSubBandsPerSegment.size() > 1)
+    {
+        const auto offset = (((allocatedSubBandsPerSegment.front().back().second -
+                               allocatedSubBandsPerSegment.front().front().first) /
+                              2) +
+                             (allocatedSubBandsPerSegment.back().front().first -
+                              allocatedSubBandsPerSegment.front().back().second) +
+                             ((allocatedSubBandsPerSegment.back().back().second -
+                               allocatedSubBandsPerSegment.back().front().first) /
+                              2));
+        outerBandsLeft.emplace_back(outerBandsLeft.front().first + offset,
+                                    outerBandsLeft.front().second + offset);
+        middleBandsLeft.emplace_back(middleBandsLeft.front().first + offset,
+                                     middleBandsLeft.front().second + offset);
+        flatJunctionsLeft.emplace_back(flatJunctionsLeft.front().first + offset,
+                                       flatJunctionsLeft.front().second + offset);
+        innerBandsLeft.emplace_back(innerBandsLeft.front().first + offset,
+                                    innerBandsLeft.front().second + offset);
+        allocatedSubBands.emplace_back(allocatedSubBands.front().first + offset,
+                                       allocatedSubBands.front().second + offset);
+        innerBandsRight.emplace_back(innerBandsRight.front().first + offset,
+                                     innerBandsRight.front().second + offset);
+        flatJunctionsRight.emplace_back(flatJunctionsRight.front().first + offset,
+                                        flatJunctionsRight.front().second + offset);
+        middleBandsRight.emplace_back(middleBandsRight.front().first + offset,
+                                      middleBandsRight.front().second + offset);
+        outerBandsRight.emplace_back(outerBandsRight.front().first + offset,
+                                     outerBandsRight.front().second + offset);
+        betweenPsdsBand.emplace(middleBandsRight.front().first, middleBandsLeft.back().second);
+    }
+
     std::ostringstream ss;
-    ss << "outerBandLeft=[" << outerBandLeft.first << ";" << outerBandLeft.second << "] "
-       << "middleBandLeft=[" << middleBandLeft.first << ";" << middleBandLeft.second << "] "
-       << "flatJunctionLeft=[" << flatJunctionLeft.first << ";" << flatJunctionLeft.second << "] "
-       << "innerBandLeft=[" << innerBandLeft.first << ";" << innerBandLeft.second << "] "
-       << "subBands=[" << allocatedSubBands.front().first << ";" << allocatedSubBands.back().second
-       << "] ";
-    if (!puncturedBands.empty())
-    {
-        ss << "puncturedBands=[" << puncturedBands.front().first << ";"
-           << puncturedBands.back().second << "] ";
-    }
-    ss << "innerBandRight=[" << innerBandRight.first << ";" << innerBandRight.second << "] "
-       << "flatJunctionRight=[" << flatJunctionRight.first << ";" << flatJunctionRight.second
-       << "] "
-       << "middleBandRight=[" << middleBandRight.first << ";" << middleBandRight.second << "] "
-       << "outerBandRight=[" << outerBandRight.first << ";" << outerBandRight.second << "] ";
+    for (std::size_t i = 0; i < allocatedSubBandsPerSegment.size(); ++i)
+    {
+        if (allocatedSubBandsPerSegment.size() > 1)
+        {
+            ss << "PSD" << i + 1 << ": ";
+        }
+        ss << "outerBandLeft=[" << outerBandsLeft.at(i).first << ";" << outerBandsLeft.at(i).second
+           << "] "
+           << "middleBandLeft=[" << middleBandsLeft.at(i).first << ";"
+           << middleBandsLeft.at(i).second << "] "
+           << "flatJunctionLeft=[" << flatJunctionsLeft.at(i).first << ";"
+           << flatJunctionsLeft.at(i).second << "] "
+           << "innerBandLeft=[" << innerBandsLeft.at(i).first << ";" << innerBandsLeft.at(i).second
+           << "] "
+           << "allocatedBand=[" << allocatedSubBands.at(i).first << ";"
+           << allocatedSubBands.at(i).second << "] ";
+        if (!puncturedBandsPerSegment.empty() && !puncturedBandsPerSegment.at(i).empty())
+        {
+            ss << "puncturedBands=[" << puncturedBandsPerSegment.at(i).front().first << ";"
+               << puncturedBandsPerSegment.at(i).back().second << "] ";
+        }
+        ss << "innerBandRight=[" << innerBandsRight.at(i).first << ";"
+           << innerBandsRight.at(i).second << "] "
+           << "flatJunctionRight=[" << flatJunctionsRight.at(i).first << ";"
+           << flatJunctionsRight.at(i).second << "] "
+           << "middleBandRight=[" << middleBandsRight.at(i).first << ";"
+           << middleBandsRight.at(i).second << "] "
+           << "outerBandRight=[" << outerBandsRight.at(i).first << ";"
+           << outerBandsRight.at(i).second << "] ";
+    }
+    if (allocatedSubBandsPerSegment.size() > 1)
+    {
+        ss << "=> PSD: "
+           << "outerBandLeft=[" << outerBandsLeft.front().first << ";"
+           << outerBandsLeft.front().second << "] "
+           << "middleBandLeft=[" << middleBandsLeft.front().first << ";"
+           << middleBandsLeft.front().second << "] "
+           << "flatJunctionLeft=[" << flatJunctionsLeft.front().first << ";"
+           << flatJunctionsLeft.front().second << "] "
+           << "innerBandLeft=[" << innerBandsLeft.front().first << ";"
+           << innerBandsLeft.front().second << "] "
+           << "allocatedBandInPsd1=[" << allocatedSubBands.front().first << ";"
+           << allocatedSubBands.front().second << "] ";
+        if (!puncturedBandsPerSegment.empty() && !puncturedBandsPerSegment.front().empty())
+        {
+            ss << "puncturedBandsInPsd1=[" << puncturedBandsPerSegment.front().front().first << ";"
+               << puncturedBandsPerSegment.front().back().second << "] ";
+        }
+        ss << "flatJunctionRightPsd1=[" << flatJunctionsRight.front().first << ";"
+           << flatJunctionsRight.front().second << "] "
+           << "linearSum=[" << betweenPsdsBand->first << ";" << betweenPsdsBand->second << "] "
+           << "flatJunctionLeftPsd2=[" << flatJunctionsLeft.back().first << ";"
+           << flatJunctionsLeft.back().second << "] "
+           << "innerBandLeftPsd2=[" << innerBandsLeft.back().first << ";"
+           << innerBandsLeft.back().second << "] "
+           << "allocatedBandInPsd2=[" << allocatedSubBands.back().first << ";"
+           << allocatedSubBands.back().second << "] ";
+        if (!puncturedBandsPerSegment.empty() && !puncturedBandsPerSegment.back().empty())
+        {
+            ss << "puncturedBandsInPsd2=[" << puncturedBandsPerSegment.back().front().first << ";"
+               << puncturedBandsPerSegment.back().back().second << "] ";
+        }
+        ss << "innerBandRight=[" << innerBandsRight.back().first << ";"
+           << innerBandsRight.back().second << "] "
+           << "flatJunctionRight=[" << flatJunctionsRight.back().first << ";"
+           << flatJunctionsRight.back().second << "] "
+           << "middleBandRight=[" << middleBandsRight.back().first << ";"
+           << middleBandsRight.back().second << "] "
+           << "outerBandRight=[" << outerBandsRight.back().first << ";"
+           << outerBandsRight.back().second << "] ";
+    }
     NS_LOG_DEBUG(ss.str());
+    NS_ASSERT(maskBand.second == outerBandsRight.back().second);
     NS_ASSERT(numMaskBands ==
-              ((allocatedSubBands.back().second - allocatedSubBands.front().first +
+              ((allocatedSubBandsPerSegment.back().back().second -
+                allocatedSubBandsPerSegment.front().front().first +
                 1) // equivalent to allocatedBand (includes notches and DC)
-               + 2 * (innerSlopeWidth + middleSlopeWidth + outerSlopeWidth) +
-               (flatJunctionLeft.second - flatJunctionLeft.first + 1) // flat junctions
-               + (flatJunctionRight.second - flatJunctionRight.first + 1)));
+               + 2 * (innerSlopeWidth + middleSlopeWidth + outerSlopeWidth + flatJunctionWidth)));
 
     // Different slopes
-    double innerSlope = (-1 * minInnerBandDbr) / innerSlopeWidth;
-    double middleSlope = (-1 * (minOuterBandDbr - minInnerBandDbr)) / middleSlopeWidth;
-    double outerSlope = (txPowerMiddleBandMinDbm - txPowerOuterBandMinDbm) / outerSlopeWidth;
-    double puncturedSlope = (-1 * minInnerBandDbr) / puncturedSlopeWidth;
+    double innerSlope = (-1.0 * minInnerBand) / innerSlopeWidth;
+    double middleSlope = (-1.0 * (minOuterBand - minInnerBand)) / middleSlopeWidth;
+    double outerSlope = (txPowerMiddleBandMin - txPowerOuterBandMin) / outerSlopeWidth;
+    double puncturedSlope = (-1.0 * minInnerBand) / puncturedSlopeWidth;
 
     // Build spectrum mask
-    auto vit = c->ValuesBegin();
-    auto bit = c->ConstBandsBegin();
-    double txPowerW = 0.0;
-    double previousTxPowerW = 0.0;
-    for (size_t i = 0; i < numBands; i++, vit++, bit++)
+    Watt_u previousTxPower = 0.0;
+    std::vector<Watt_u> txPowerValues(numBands);
+    NS_ASSERT(txPowerValues.size() == numBands);
+    for (size_t i = 0; i < numBands; ++i)
     {
+        size_t psdIndex =
+            (allocatedSubBandsPerSegment.size() == 1) ? 0 : ((i < (numBands / 2)) ? 0 : 1);
+        Watt_u txPower = 0.0;
         if (i < maskBand.first || i > maskBand.second) // outside the spectrum mask
         {
-            txPowerW = 0.0;
+            txPower = 0.0;
         }
-        else if (i <= outerBandLeft.second &&
-                 i >= outerBandLeft.first) // better to put greater first (less computation)
+        else if (betweenPsdsBand.has_value() &&
+                 (i <= betweenPsdsBand->second && i >= betweenPsdsBand->first))
         {
-            txPowerW = DbmToW(txPowerOuterBandMinDbm + ((i - outerBandLeft.first) * outerSlope));
+            // value for PSD mask 1
+            std::vector<double> txPowerWPsds(2);
+            if (i <= middleBandsRight.at(0).second && i >= middleBandsRight.at(0).first)
+            {
+                txPowerWPsds.at(0) =
+                    DbmToW(txPowerInnerBandMin -
+                           ((i - middleBandsRight.at(0).first + 1) *
+                            middleSlope)); // +1 so as to be symmetric with left slope
+            }
+            else if (i <= outerBandsRight.at(0).second && i >= outerBandsRight.at(0).first)
+            {
+                txPowerWPsds.at(0) =
+                    DbmToW(txPowerMiddleBandMin -
+                           ((i - outerBandsRight.at(0).first + 1) *
+                            outerSlope)); // +1 so as to be symmetric with left slope
+            }
+            else if (i > outerBandsRight.at(0).second)
+            {
+                txPower = DbmToW(txPowerOuterBandMin);
+            }
+            else
+            {
+                NS_ASSERT(false);
+            }
+
+            // value for PSD mask 2
+            if (i < outerBandsLeft.at(1).first)
+            {
+                txPower = DbmToW(txPowerOuterBandMin);
+            }
+            else if (i <= outerBandsLeft.at(1).second && i >= outerBandsLeft.at(1).first)
+            {
+                txPowerWPsds.at(1) =
+                    DbmToW(txPowerOuterBandMin + ((i - outerBandsLeft.at(1).first) * outerSlope));
+            }
+            else if (i <= middleBandsLeft.at(1).second && i >= middleBandsLeft.at(1).first)
+            {
+                txPowerWPsds.at(1) = DbmToW(txPowerMiddleBandMin +
+                                            ((i - middleBandsLeft.at(1).first) * middleSlope));
+            }
+            else
+            {
+                NS_ASSERT(false);
+            }
+
+            txPower = std::accumulate(txPowerWPsds.cbegin(), txPowerWPsds.cend(), 0.0);
+            txPower = std::max(DbmToW(txPowerRef - 25.0), txPower);
+            txPower = std::min(DbmToW(txPowerRef - 20.0), txPower);
+        }
+        else if (i <= outerBandsLeft.at(psdIndex).second &&
+                 i >= outerBandsLeft.at(psdIndex)
+                          .first) // better to put greater first (less computation)
+        {
+            txPower = DbmToW(txPowerOuterBandMin +
+                             ((i - outerBandsLeft.at(psdIndex).first) * outerSlope));
         }
-        else if (i <= middleBandLeft.second && i >= middleBandLeft.first)
+        else if (i <= middleBandsLeft.at(psdIndex).second &&
+                 i >= middleBandsLeft.at(psdIndex).first)
         {
-            txPowerW = DbmToW(txPowerMiddleBandMinDbm + ((i - middleBandLeft.first) * middleSlope));
+            txPower = DbmToW(txPowerMiddleBandMin +
+                             ((i - middleBandsLeft.at(psdIndex).first) * middleSlope));
         }
-        else if ((i <= flatJunctionLeft.second && i >= flatJunctionLeft.first) ||
-                 (i <= flatJunctionRight.second && i >= flatJunctionRight.first))
+        else if ((i <= flatJunctionsLeft.at(psdIndex).second &&
+                  i >= flatJunctionsLeft.at(psdIndex).first) ||
+                 (i <= flatJunctionsRight.at(psdIndex).second &&
+                  i >= flatJunctionsRight.at(psdIndex).first))
         {
-            txPowerW = DbmToW(txPowerInnerBandMinDbm);
+            txPower = DbmToW(txPowerInnerBandMin);
         }
-        else if (i <= innerBandLeft.second && i >= innerBandLeft.first)
+        else if (i <= innerBandsLeft.at(psdIndex).second && i >= innerBandsLeft.at(psdIndex).first)
         {
-            txPowerW =
-                (!puncturedBands.empty() &&
-                 (puncturedBands.front().first <= allocatedSubBands.front().first))
-                    ? DbmToW(txPowerInnerBandMinDbm)
-                    : // first 20 MHz band is punctured
-                    DbmToW(txPowerInnerBandMinDbm + ((i - innerBandLeft.first) * innerSlope));
+            txPower = (!puncturedBandsPerSegment.empty() &&
+                       !puncturedBandsPerSegment.at(psdIndex).empty() &&
+                       (puncturedBandsPerSegment.at(psdIndex).front().first <=
+                        allocatedSubBandsPerSegment.at(psdIndex).front().first))
+                          ? DbmToW(txPowerInnerBandMin)
+                          : // first 20 MHz band is punctured
+                          DbmToW(txPowerInnerBandMin +
+                                 ((i - innerBandsLeft.at(psdIndex).first) * innerSlope));
         }
-        else if (i <= allocatedSubBands.back().second &&
-                 i >= allocatedSubBands.front().first) // roughly in allocated band
+        else if ((i <= allocatedSubBandsPerSegment.at(psdIndex).back().second &&
+                  i >= allocatedSubBandsPerSegment.at(psdIndex).front().first)) // roughly in
+                                                                                // allocated band
         {
             bool insideSubBand = false;
             for (uint32_t j = 0; !insideSubBand && j < numSubBands;
                  j++) // continue until inside a sub-band
             {
-                insideSubBand =
-                    (i <= allocatedSubBands[j].second) && (i >= allocatedSubBands[j].first);
+                insideSubBand = (i <= allocatedSubBandsPerSegment.at(psdIndex)[j].second) &&
+                                (i >= allocatedSubBandsPerSegment.at(psdIndex)[j].first);
             }
             if (insideSubBand)
             {
                 bool insidePuncturedSubBand = false;
-                uint32_t j = 0;
-                for (; !insidePuncturedSubBand && j < puncturedBands.size();
+                std::size_t j = 0;
+                std::size_t puncturedBandSize = !puncturedBandsPerSegment.empty()
+                                                    ? puncturedBandsPerSegment.at(psdIndex).size()
+                                                    : 0;
+                for (; !insidePuncturedSubBand && j < puncturedBandSize;
                      j++) // continue until inside a punctured sub-band
                 {
                     insidePuncturedSubBand =
-                        (i <= puncturedBands[j].second) && (i >= puncturedBands[j].first);
+                        (i <= puncturedBandsPerSegment.at(psdIndex).at(j).second) &&
+                        (i >= puncturedBandsPerSegment.at(psdIndex).at(j).first);
                 }
                 if (insidePuncturedSubBand)
                 {
                     uint32_t startPuncturedSlope =
-                        (puncturedBands[puncturedBands.size() - 1].second -
+                        (puncturedBandsPerSegment.at(psdIndex)
+                             .at(puncturedBandsPerSegment.at(psdIndex).size() - 1)
+                             .second -
                          puncturedSlopeWidth); // only consecutive subchannels can be punctured
                     if (i >= startPuncturedSlope)
                     {
-                        txPowerW = DbmToW(txPowerInnerBandMinDbm +
-                                          ((i - startPuncturedSlope) * puncturedSlope));
+                        txPower = DbmToW(txPowerInnerBandMin +
+                                         ((i - startPuncturedSlope) * puncturedSlope));
                     }
                     else
                     {
-                        txPowerW = std::max(DbmToW(txPowerInnerBandMinDbm),
-                                            DbmToW(txPowerRefDbm - ((i - puncturedBands[0].first) *
-                                                                    puncturedSlope)));
+                        txPower = std::max(
+                            DbmToW(txPowerInnerBandMin),
+                            DbmToW(txPowerRef -
+                                   ((i - puncturedBandsPerSegment.at(psdIndex).at(0).first) *
+                                    puncturedSlope)));
                     }
                 }
                 else
                 {
-                    txPowerW = txPowerPerBandW;
+                    txPower = txPowerPerBand;
                 }
             }
             else
             {
-                txPowerW = DbmToW(txPowerInnerBandMinDbm);
+                txPower = DbmToW(txPowerInnerBandMin);
             }
         }
-        else if (i <= innerBandRight.second && i >= innerBandRight.first)
+        else if (i <= innerBandsRight.at(psdIndex).second &&
+                 i >= innerBandsRight.at(psdIndex).first)
         {
             // take min to handle the case where last 20 MHz band is punctured
-            txPowerW = std::min(
-                previousTxPowerW,
-                DbmToW(txPowerRefDbm - ((i - innerBandRight.first + 1) *
-                                        innerSlope))); // +1 so as to be symmetric with left slope
-        }
-        else if (i <= middleBandRight.second && i >= middleBandRight.first)
-        {
-            txPowerW = DbmToW(txPowerInnerBandMinDbm -
-                              ((i - middleBandRight.first + 1) *
-                               middleSlope)); // +1 so as to be symmetric with left slope
-        }
-        else if (i <= outerBandRight.second && i >= outerBandRight.first)
-        {
-            txPowerW = DbmToW(txPowerMiddleBandMinDbm -
-                              ((i - outerBandRight.first + 1) *
-                               outerSlope)); // +1 so as to be symmetric with left slope
+            txPower = std::min(
+                previousTxPower,
+                DbmToW(txPowerRef - ((i - innerBandsRight.at(psdIndex).first + 1) *
+                                     innerSlope))); // +1 so as to be symmetric with left slope
+        }
+        else if (i <= middleBandsRight.at(psdIndex).second &&
+                 i >= middleBandsRight.at(psdIndex).first)
+        {
+            txPower = DbmToW(txPowerInnerBandMin -
+                             ((i - middleBandsRight.at(psdIndex).first + 1) *
+                              middleSlope)); // +1 so as to be symmetric with left slope
+        }
+        else if (i <= outerBandsRight.at(psdIndex).second &&
+                 i >= outerBandsRight.at(psdIndex).first)
+        {
+            txPower = DbmToW(txPowerMiddleBandMin -
+                             ((i - outerBandsRight.at(psdIndex).first + 1) *
+                              outerSlope)); // +1 so as to be symmetric with left slope
         }
         else
         {
             NS_FATAL_ERROR("Should have handled all cases");
         }
-        double txPowerDbr = 10 * std::log10(txPowerW / txPowerPerBandW);
-        NS_LOG_LOGIC(uint32_t(i) << " -> " << txPowerDbr);
-        *vit = txPowerW / (bit->fh - bit->fl);
-        previousTxPowerW = txPowerW;
+        NS_LOG_LOGIC(i << " -> " << (10 * std::log10(txPower / txPowerPerBand)));
+        previousTxPower = txPower;
+        txPowerValues.at(i) = txPower;
+    }
+
+    // fill in spectrum mask
+    auto vit = c->ValuesBegin();
+    auto bit = c->ConstBandsBegin();
+    const auto invBandwidth = 1 / (bit->fh - bit->fl);
+    for (auto txPowerValue : txPowerValues)
+    {
+        *vit = txPowerValue * invBandwidth;
+        vit++;
+        bit++;
+    }
+
+    for (const auto& allocatedSubBands : allocatedSubBandsPerSegment)
+    {
+        NS_LOG_INFO("Added signal power to subbands " << allocatedSubBands.front().first << "-"
+                                                      << allocatedSubBands.back().second);
     }
-    NS_LOG_INFO("Added signal power to subbands " << allocatedSubBands.front().first << "-"
-                                                  << allocatedSubBands.back().second);
 }
 
 void
-WifiSpectrumValueHelper::NormalizeSpectrumMask(Ptr<SpectrumValue> c, double txPowerW)
+WifiSpectrumValueHelper::NormalizeSpectrumMask(Ptr<SpectrumValue> c, Watt_u txPower)
 {
-    NS_LOG_FUNCTION(c << txPowerW);
+    NS_LOG_FUNCTION(c << txPower);
     // Normalize power so that total signal power equals transmit power
-    double currentTxPowerW = Integral(*c);
-    double normalizationRatio = currentTxPowerW / txPowerW;
-    NS_LOG_LOGIC("Current power: " << currentTxPowerW << "W vs expected power: " << txPowerW << "W"
+    Watt_u currentTxPower = Integral(*c);
+    double normalizationRatio [[maybe_unused]] = currentTxPower / txPower;
+    double invNormalizationRatio = txPower / currentTxPower;
+    NS_LOG_LOGIC("Current power: " << currentTxPower << "W vs expected power: " << txPower << "W"
                                    << " -> ratio (C/E) = " << normalizationRatio);
     auto vit = c->ValuesBegin();
     for (size_t i = 0; i < c->GetSpectrumModel()->GetNumBands(); i++, vit++)
     {
-        *vit = (*vit) / normalizationRatio;
+        *vit = (*vit) * invNormalizationRatio;
     }
 }
 
-double
-WifiSpectrumValueHelper::DbmToW(double dBm)
+Watt_u
+WifiSpectrumValueHelper::GetBandPowerW(Ptr<SpectrumValue> psd,
+                                       const std::vector<WifiSpectrumBandIndices>& segments)
 {
-    return std::pow(10.0, 0.1 * (dBm - 30.0));
-}
-
-double
-WifiSpectrumValueHelper::GetBandPowerW(Ptr<SpectrumValue> psd, const WifiSpectrumBandIndices& band)
-{
-    auto valueIt = psd->ConstValuesBegin() + band.first;
-    auto end = psd->ConstValuesBegin() + band.second;
-    auto bandIt = psd->ConstBandsBegin() + band.first; // all bands have same width
+    auto powerWattPerHertz{0.0};
+    auto bandIt = psd->ConstBandsBegin() + segments.front().first; // all bands have same width
     const auto bandWidth = (bandIt->fh - bandIt->fl);
     NS_ASSERT_MSG(bandWidth >= 0.0,
                   "Invalid width for subband [" << bandIt->fl << ";" << bandIt->fh << "]");
-    uint32_t index{0};
-    auto powerWattPerHertz{0.0};
-    while (valueIt <= end)
+    for (const auto& [start, stop] : segments)
     {
-        NS_ASSERT_MSG(*valueIt >= 0.0,
-                      "Invalid power value " << *valueIt << " in subband " << index);
-        powerWattPerHertz += *valueIt;
-        ++valueIt;
-        ++index;
-    }
-    const auto power = powerWattPerHertz * bandWidth;
-    NS_ASSERT_MSG(power >= 0.0,
-                  "Invalid calculated power " << power << " for band [" << band.first << ";"
-                                              << band.second << "]");
+        auto valueIt = psd->ConstValuesBegin() + start;
+        auto end = psd->ConstValuesBegin() + stop;
+        uint32_t index [[maybe_unused]] = 0;
+        while (valueIt <= end)
+        {
+            NS_ASSERT_MSG(*valueIt >= 0.0,
+                          "Invalid power value " << *valueIt << " in subband " << index);
+            powerWattPerHertz += *valueIt;
+            ++valueIt;
+            ++index;
+        }
+    }
+    const Watt_u power = powerWattPerHertz * bandWidth;
+    NS_ASSERT_MSG(power >= 0.0, "Invalid calculated power " << power);
     return power;
 }
 
